﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Telerik.Windows.Controls;
using System.Collections.ObjectModel;
using Telerik.Windows.Controls.ScheduleView;


namespace RadScheduleFiltering
{
	public class ScheduleViewVM : ViewModelBase
	{
		 public ObservableCollection<Appointment> Appointments { get; set; }
        public ObservableCollection<ResourceType> ResourceTypes { get; set; }
        public ObservableCollection<Resource> ComboResources { get; set; }

        private Resource selectedResource;
        public Resource SelectedResource 
        {
            get { return selectedResource; }
            set
            {
                if ( selectedResource != value)
                {
                    selectedResource = value;
                    OnPropertyChanged(() => this.SelectedResource);
                    OnPropertyChanged(() => this.FilterValue);
                }
            }
        }

        public ScheduleViewVM()
        {
            MakeAppointments();
            MakeResources();
        }

        private void MakeAppointments()
        {
			var now = DateTime.Now;
			var app1 = new Appointment()
			{
				Subject = "Enchev App",
				Start = now,
				End = now.AddHours(2)
			};
			app1.Resources.Add(new Resource("Hall A", "Location"));
			app1.Resources.Add(new Resource("Enchev", "Speaker"));

			var app2 = new Appointment()
			{
				Subject = "Milev App",
				Start = now,
				End = now.AddHours(2)
			};
			app2.Resources.Add(new Resource("Hall A", "Location"));
			app2.Resources.Add(new Resource("Milev", "Speaker"));

            Appointments = new ObservableCollection<Appointment>() { app1, app2 };
           
        }

        private void MakeResources()
        {
            ResourceTypes = new ObservableCollection<ResourceType>();
            ResourceType rt = new ResourceType("Location");
            rt.Resources.Add(new Resource("Hall A", "Location"));
            rt.Resources.Add(new Resource("Hall B", "Location"));
            rt.Resources.Add(new Resource("Hall C", "Location"));
            ResourceTypes.Add(rt);

            ResourceType newRT = new ResourceType("Speaker");
            ComboResources = new ObservableCollection<Resource>();
            ComboResources.Add(new Resource("Enchev", "Speaker"));
            ComboResources.Add(new Resource("Milev", "Speaker"));
            ComboResources.Add(new Resource("Donchev", "Speaker"));

            newRT.Resources.AddRange(ComboResources);
            ResourceTypes.Add(newRT);

        }

        public Predicate<IAppointment> FilterValue
        {
            get { return Filter; }
        }

        public bool Filter(IAppointment appt)
        {
            Appointment app = appt as Appointment;
            return app != null && FilterBySpeaker(app);
        }

        public bool FilterBySpeaker(Appointment app)
        {
            return SelectedResource == null || 
                app.Resources.Contains(SelectedResource);
        }
	}
}
